<?php
require_once 'System.php';
//require_once(dirname(__FILE__).'/include/constants.php');
//require_once(dirname(__FILE__).'/include/session.php');
//require_once(dirname(__FILE__).'/include/functions.php');
//require_once(dirname(__FILE__).'/include/fileserver.php');

require_once(dirname(__FILE__).'/constants.php');
require_once(dirname(__FILE__).'/session.php');
require_once(dirname(__FILE__).'/fileserver.php');


global $session, $logger;
$logger->log("RUN>>>>>>> fs_getfile.php ");


function convertVoiceFile($filename, $filetitle) {
	global $logger;
	$logger->log("convertVoiceFile($filename, '$filetitle')");

	$rec_artist = '';
	if (strpos($filetitle, '|') > 0) {
		list(,$rec_artist, $rec_title) = explode('|', $filetitle, 3);
		/*switch ($rec_artist) {
			case DB_TAR_SERVICETYPE_MTR:
				$rec_artist = 'Запись разговора';
				break;
			case DB_TAR_SERVICETYPE_VOICE:
				$rec_artist = 'Голосовое сообщение';
				break;
		}*/
	}
	if (strlen($rec_artist) == 0) {
		$rec_artist = ' ';
		$rec_title = $filetitle;
	}

	$outfile = System::mktemp('aout_');
	$cnvt = AUDIO_CONVERT_CALL_FMT;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	$cnvt = str_ireplace('%artist%', $rec_artist, $cnvt);
	$cnvt = str_ireplace('%title%', $rec_title, $cnvt);
	$logger->log("convertVoiceFile($filename)->$cnvt");
	exec($cnvt);
	return $outfile;
}

function sendVoiceFile($filename, $filetitle = '', $filemode = '!save') {
	global $logger;
	$logger->log("sendVoiceFile($filename, '$filetitle')");

	if (strpos($filetitle, '|') > 0) {
		list($rec_type, $rec_date, $rec_title) = explode('|', $filetitle, 3);
		switch ($rec_type) {
			case DB_TAR_SERVICETYPE_MTR:
				$rec_date = 'Запись разговора ' . $rec_date;
				break;
			case DB_TAR_SERVICETYPE_VOICE:
				$rec_date = 'Голосовое сообщение ' . $rec_date;
				break;
		}
		$outfilename = $rec_date . ' ' . $rec_title . '.mp3';
	} else
		$outfilename = empty($filetitle) ? $filename : $filetitle . '.mp3';

	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', FALSE);
	header('Pragma: no-cache');
	header('Content-Type: audio/mpeg');
	header('Content-Length: ' . filesize($filename));
	if ($filemode == 'save') {
		header('Content-Disposition: attachment; filename="' . $outfilename . '";size=' . filesize($filename));
		header('Content-Transfer-Encoding: binary');
		header('Content-Description: File Transfer');
	}

	$res = false;
	ob_start();
	if (($fp = fopen($filename, 'r'))) {
		while (!feof($fp)) {
			$buff = fread($fp, 4096);
			print $buff;
		}
		fclose($fp);
		$logger->log("sendVoiceFile($filename, '$filetitle', '$filemode') -> SENT ".filesize($filename)." bytes");
		$res = true;
	} else
		$logger->log("sendVoiceFile($filename, '$filetitle', '$filemode') -> OPENING ERROR");
	ob_end_flush();
	flush();
	return $res;
}

function convertFaxFile($filename) {
	global $logger;
	$logger->log("convertFaxFile($filename)");

	$outfilename = System::mktemp('aout_');
	$outfile = $outfilename . '.jpg';
	$cnvt = FAX_CONVERT_CALL_FMT;
	$cnvt = str_ireplace('%infile%', $filename, $cnvt);
	$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
	$logger->log("convertFaxFile($filename)->$cnvt");
	exec($cnvt);
	if (is_readable($outfile) && filesize($outfile) > 0)
		return $outfile;

	$pages = 0;
	$pagefiles = '';
	while (is_readable("{$outfilename}-{$pages}.jpg") && filesize("{$outfilename}-{$pages}.jpg") > 0) {
		$pagefiles .= "{$outfilename}-{$pages}.jpg ";
		$pages++;
	}
	if ($pages > 0) {
		$outfile = System::mktemp('aout_') . '.jpg';
		$cnvt = FAX_CONVERT_CALL_FMT2;
		$cnvt = str_ireplace('%infile%', $pagefiles, $cnvt);
		$cnvt = str_ireplace('%outfile%', $outfile, $cnvt);
		$logger->log("convertFaxFileMultipage($filename)->$cnvt");
		exec($cnvt);

		for ($i = 0; $i < $pages; $i++)
			unlink("{$outfilename}-{$i}.jpg");
	}
	if (is_readable($outfile) && filesize($outfile) > 0)
		return $outfile;
	else
		return '';
}

function sendFaxFile($filename, $filetitle = '', $filemode = '!save', $fileremove = true) {
	global $logger;
	$logger->log("sendFaxFile($filename, '$filetitle')");

	$fileext = ($filemode == 'save' && $filename != FAX_ERROR_FILESERVER) ? '.tiff' : '.jpg';

	if (strpos($filetitle, '|') > 0) {
		list($rec_type, $rec_date, $rec_title) = explode('|', $filetitle, 3);
		switch ($rec_type) {
			case DB_TAR_SERVICETYPE_FAX:
				$rec_date = 'Факсимильное сообщение ' . $rec_date;
				break;
		}
		$outfilename = $rec_date . ' ' . $rec_title . $fileext;
	} else
		$outfilename = empty($filetitle) ? $filename : $filetitle . $fileext;

	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', FALSE);
	header('Pragma: no-cache');
	if ($filemode == 'save' && $filename != FAX_ERROR_FILESERVER)
		header('Content-Type: image/tiff');
	else
		header('Content-Type: image/jpeg');
	header('Content-Transfer-Encoding: binary');
	header('Content-Length: ' . filesize($filename));
	if ($filemode == 'save') {
		header('Content-Disposition: attachment; filename="' . $outfilename . '";size=' . filesize($filename));
		header('Content-Description: File Transfer');
	}

	$res = false;
	ob_start();
	if (($fp = fopen($filename, 'r'))) {
		while (!feof($fp)) {
			$buff = fread($fp, 4096);
			print $buff;
		}
		fclose($fp);
		$logger->log("sendFaxFile($filename, '$filetitle', '$filemode') -> SENT ".filesize($filename)." bytes");
		$res = true;
	} else
		$logger->log("sendFaxFile($filename, '$filetitle', '$filemode') -> OPENING ERROR");
	ob_end_flush();
	flush();
	if ($fileremove)
		unlink($filename);
	return $res;
}


global $session, $logger;
//$logger->log("REQUEST(".basename($_SERVER['SCRIPT_NAME']).":\n".print_r($_REQUEST, true));
//$logger->log("session->db_ok:".print_r($session->db_ok, true));
//$logger->log("session->logged_in:".print_r($session->logged_in, true));

//if (($session->db_ok && $session->logged_in || isset($_COOKIE['office_menuid']))
//	&& isset($_REQUEST['id'])) {
if ($session->logged_in) {
	
	global $fileserver_control;

	$fileid = array_pop(explode(',', urldecode($_REQUEST['id'])));
	$filetype = (isset($_REQUEST['type']) && $_REQUEST['type'] == 'fax') ? 'fax' : 'voice';
	$filetitle = isset($_REQUEST['ttl']) ? base64_decode(rawurldecode($_REQUEST['ttl'])) : $fileid;
	$filetitle = trim($filetitle);
	$filemode = (isset($_REQUEST['m']) && ($_REQUEST['m'] == 'save')) ? 'save' : '';

	//$logger->log('ttl='.iconv('utf-8', 'cp1251//IGNORE', $filetitle));

	$file = System::mktemp('ain_');
	//$fileserver_control->DebugMode=true;
	$res = $fileserver_control->ReceiveFile($fileid, $file);
	$logger->log("ReceiveFile($fileid) -> $res");
	if ($res == FS_ERROR_OK) {
		if ($filetype == 'fax') {
			if ($filemode != 'save')
				$file = convertFaxFile($file/*, $fileid, $filetitle*/);
			if (is_readable($file) && filesize($file) > 0)
				sendFaxFile($file, $filetitle, $filemode);
			else
				sendFaxFile(FAX_ERROR_FILESERVER, 'Error - File Not Found', $filemode, false);
		} else {
			$file = convertVoiceFile($file, /*$fileid,*/ $filetitle);
			if (is_readable($file) && filesize($file) > 0)
				sendVoiceFile($file, $filetitle, $filemode);
			else
				sendVoiceFile(AUDIO_ERROR_FILESERVER, 'Error - File Not Found', $filemode);
		}
		//sendDataFile('d:\WinApps\eclipse\workspace\vo\vinny.mp3');
	} else {
		if ($filetype == 'fax')
			sendFaxFile(FAX_ERROR_FILESERVER, 'Error - File Not Found', $filemode, false);
		else
			sendVoiceFile(AUDIO_ERROR_FILESERVER, 'Error - File Not Found', $filemode);
	}
} else {
	$logger->log("getfile({$_REQUEST['id']}) -> " . AUDIO_ERROR_NOTAUTHORIZED);
	sendVoiceFile(AUDIO_ERROR_NOTAUTHORIZED, 'Error - Not Authorized');
}
?>
